/*
MiniBrowser
Purpose is to build a quick Record Collection browser, allowing you to type any keystroke
and immediately seek in the database on that.
*/


#include <hmg.ch>
function main()
local aHeaders:={"Nummer","Trk","Artiest","Titel"}
local aWidths:={65,35,248,249}
local acFields:={"MUSIC->NR","MUSIC->DTR","MUSIC->ARTIEST","MUSIC->TITEL"}
local cSMsg:="Type to Search - Click on title to Change Sort Order - F2 to clear search"
public cStr:="", cVal

REQUEST DBFNSX
// RDDSETDEFAULT("DBFNSX")
SET BROWSESYNC ON
SET DATE FRENCH

dbUseArea(.T.,"DBFNSX","MUSIC",.F.)
OrdSetFocus(5)
dbGoTop()

DEFINE WINDOW MainForm;
	AT 90,90;
	WIDTH 645;
	HEIGHT 403;
  TITLE "MiniBrowser";
	ON RELEASE Closedb();
	ON SIZE ResizeForm();
	MAIN
	
	ON KEY F2 ACTION ResetSearch()
	
	DEFINE STATUSBAR 
		STATUSITEM cSMsg 
		CLOCK
		DATE
		STATUSITEM " " WIDTH 15 //In Windows 7, year is hidden by corner
	END STATUSBAR
		
END WINDOW

@ 5,5 BROWSE br_Main;
  OF MainForm;
  WIDTH 620;
	HEIGHT 332;
	HEADERS aHeaders;
	WIDTHS aWidths;
	WORKAREA MUSIC;
	FIELDS acFields;
	ON HEADCLICK { {||Resort(5)} , {||MsgInfo('Not an Index Key')} , {||Resort(1)},{||Resort(2)}};
	JUSTIFY { BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_LEFT,BROWSE_JTFY_LEFT}
	
CREATE EVENT PROCNAME QuickSearch() HWND MainForm.br_Main.HANDLE MSG WM_CHAR

MainForm.Center
MainForm.Activate

return NIL

//------------------------
function ResetSearch()
cStr:=""
MainForm.Statusbar.Item(1):=cStr
return NIL
//------------------------
function QuickSearch()
local ch, hWnd
ch := HMG_GetLastCharacter(@hWnd)

Mainform.Statusbar.Item(2):=str(asc(ch))

if asc(ch) = 8
  cStr:=if(len(cStr)>1,left(cStr,len(cStr)-1),"")
else
   cStr:=cStr+upper(ch)
endif

if !DBSEEK(cStr,.T.)
  DBSKIP(-1)
endif

// HMG_CleanLastCharacter()   //Doet dat iets uit?
MainForm.Statusbar.Item(1):=cStr
MainForm.br_Main.Value:=recno()
MainForm.br_Main.Setfocus
return 1
//-----------------------
function Resort(nNum)
Ordsetfocus(nNum)
cStr:=""
MainForm.Statusbar.Item(1):=cStr
Mainform.br_Main.Refresh
return Nil
//-----------------------
function Closedb()
DBCloseAll()
Return NIL
//-----------------------
// Needed because my index is built on this function
function P_SORT(x)
return(right("   "+alltrim(x),3))
//-----------------------
function ResizeForm()

MainForm.br_Main.Width:=MainForm.Width-26
MainForm.br_Main.Height:=MainForm.Height-72

return NIL

